﻿using System;
using System.Runtime.InteropServices;
using System.Threading;

namespace FtdiDtr
{
    class Program
    {
        [DllImport("libftd2xx.so")]
        private static extern int FT_GetLibraryVersion(out int version);

        [DllImport("libftd2xx.so")]
        private static extern int FT_Open(int iport, out IntPtr ftHandle);

        [DllImport("libftd2xx.so")]
        private static extern int FT_Close(IntPtr ftHandle);

        [DllImport("libftd2xx.so")]
        private static extern int FT_SetDtr(IntPtr ftHandle);

        [DllImport("libftd2xx.so")]
        private static extern int FT_ClrDtr(IntPtr ftHandle);

        static void Main(string[] args)
        {
            int version;
            FT_GetLibraryVersion(out version);

            Console.WriteLine("FT Version: 0x" + version.ToString("x"));

            IntPtr ftHandle = IntPtr.Zero;

            Console.WriteLine("Opening...");
            int result = FT_Open(0, out ftHandle);
            Console.WriteLine(result);

            if (ftHandle != IntPtr.Zero)
            {
                FT_SetDtr(ftHandle);
                Thread.Sleep(500);
                FT_ClrDtr(ftHandle);

                Console.WriteLine("Closing...");
                FT_Close(ftHandle);
            }
        }
    }
}
